Summary: A tool for creating Scheme interfaces to C libraries
Name: g-wrap
Version: 1.9.6
Release: 2
Group: Development/Libraries
License: GPL
Requires: guile
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Prereq: /sbin/ldconfig
Source: ftp://ftp.gnucash.org/pub/g-wrap/g-wrap-%{version}.tar.gz
Source1: ia64.tar.gz
Patch0: g-wrap-info.patch
Patch1: g-wrap-glib2.patch
Patch2: g-wrap-staticffi.patch
Patch3: g-wrap-ffiexecstack.patch
Patch4: g-wrap-consistent.patch
BuildPrereq: guile-devel slib glib-devel pkgconfig autoconf

%description
This is a tool for specifying types, functions, and constants to
import into a Scheme interpreter, and for generating code (in C) to
interface these to the Guile and RScheme interpreters in particular.

%package devel
Summary: Include files and libraries needed for g-wrap development.
Group: Development/Libraries
Prereq: /sbin/install-info
Requires: g-wrap = %{version}, guile-devel, pkgconfig

%description devel
g-wrap-devel contains development libraries and headers for g-wrap.

You can provide access to a given C API by creating a specification
file describing the interface you want published at the Scheme level.
g-wrap will handle generating all the lower level library interface
code so that the C library shows up as a set of Scheme functions.

You should install g-wrap-devel if you need to compile programs that
need to use g-wrap C<->Scheme functionality

%prep
%setup -q -a 1
%patch0 -p1
#%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%build

autoconf
export CFLAGS="$RPM_OPT_FLAGS -fPIC"
%configure --disable-static
make

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}

# Move ffi headers out of standard locations to avoid apps picking
# them up, and remove the .so.

mv %{buildroot}/%{_includedir}/ffi* %{buildroot}/%{_includedir}/g-wrap

rm -f %{buildroot}/%{_libdir}/libffi.*
sed -i "s|-lffi||g" %{buildroot}/%{_libdir}/pkgconfig/*
sed -i "s|<ffi|<g-wrap/ffi|g"  %{buildroot}/%{_includedir}/g-wrap/*.h
sed -i "s|%{_libdir}/libffi.la||g" %{buildroot}/%{_libdir}/*.la
rm -f %{buildroot}/usr/share/info/dir

%clean
rm -rf %{buildroot}

%post -p /sbin/ldconfig

%post devel
/sbin/install-info \
    --info-dir=%{_infodir} %{_infodir}/g-wrap.info.gz

%postun -p /sbin/ldconfig

%postun devel
if [ "$1" = "0" ]; then
    /sbin/install-info --delete \
	--info-dir=%{_infodir} %{_infodir}/g-wrap.info.gz
fi

%files
%defattr(-,root,root)
%doc AUTHORS COPYING.LIB ChangeLog INSTALL NEWS README THANKS
%{_libdir}/*.so.*
%{_libdir}/*.la
%{_datadir}/guile/site/*

%files devel
%defattr(-,root,root)
%{_bindir}/*
%{_libdir}/*.so
%{_includedir}/*
%{_libdir}/pkgconfig/*
%doc %{_infodir}/g-wrap.info*

%changelog
* Mon Feb 27 2006 Bill Nottingham <notting@redhat.com> 1.9.6-2
- don't use an executable stack (#183287)

* Sat Feb 18 2006 Bill Nottingham <notting@redhat.com> 1.9.6-1
- update to 1.9.6, to fix incompatiblity with gcc-4.x
- disable static libs

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 1.3.4-9.2.1
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 1.3.4-9.2
- rebuilt for new gcc4.1 snapshot and glibc changes

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Thu Jul  7 2005 Bill Nottingham <notting@redhat.com> 1.3.4-9
- add patch for M4 quoting (#162649, <rc040203@freenet.de>)

* Mon Mar  7 2005 Bill Nottingham <notting@redhat.com> 1.3.4-8
- rebuild

* Tue Jun 22 2004 Than Ngo <than@redhat.com> 1.3.4-7
- don't run make check on x86_64, it doesn't like new guile
- fix build problem on x86_64/s390*

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Mar 02 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed Jun 18 2003 Bill Nottingham <notting@redhat.com> 1.3.4-4
- don't run make check on x86_64, it doesn't like new guile

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Tue Jan 14 2003 Bill Nottingham <notting@redhat.com> 1.3.4-2
- move .la files to main package (#79068)

* Mon Dec 23 2002 Bill Nottingham <notting@redhat.com> 1.3.4-1
- update to 1.3.4

* Wed Dec  4 2002 Bill Nottingham <notting@redhat.com> 1.3.2-2
- rebuild (self hosting? what's that?)

* Tue Dec  3 2002 Bill Nottingham <notting@redhat.com> 1.3.2-1
- update to 1.3.2

* Tue Dec  3 2002 Bill Nottingham <notting@redhat.com> 1.2.1-9
- rebuild against new guile

* Mon Nov 11 2002 Tim Powers <timp@redhat.com> 1.2.1-8
- rebuild to fix broken deps

* Wed Nov  6 2002 Bill Nottingham <notting@redhat.com> 1.2.1-7
- unautomated rebuild
- make it self-host (#71614)

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon Apr  8 2002 Bill Nottingham <notting@redhat.com>
- rebuild against fixed guile

* Thu Feb 21 2002 Bill Nottingham <notting@redhat.com>
- rebuild

* Tue Jan 29 2002 Bill Nottingham <notting@redhat.com>
- rebuild, thwack dependencies

* Fri Jan 25 2002 Bill Nottingham <notting@redhat.com>
- rebuild against new guile, update to 1.2.1

* Thu Jan 24 2002 Bill Nottingham <notting@redhat.com>
- rebuild

* Fri Aug  9 2001 Bill Nottingham <notting@redhat.com>
- fix builds for users without /sbin in their path

* Wed Aug  8 2001 Bill Nottingham <notting@redhat.com>
- fix build
- put a .so link in the g-wrapped directory in the main package (fixes #51129)

* Fri Jul  6 2001 Bill Nottingham <notting@redhat.com>
- tweak dependencies

* Wed Jun 27 2001 Bill Nottingham <notting@redhat.com>
- add info dir entry

* Wed Jun  6 2001 Bill Nottingham <notting@redhat.com>
- update to 1.1.10
- split out devel package

* Tue Aug 1 2000 Tim Powers <timp@redhat.com>
- fixed group to be a valid one
- fix bug #15038

* Mon Jul 24 2000 Prospector <prospector@redhat.com>
- rebuilt

* Tue Jul 11 2000 Tim Powers <timp@redhat.com>
- rebuilt

* Wed Jul 05 2000 Preston Brown <pbrown@redhat.com>
- adopted for Powertools 7.1
